<?PHP
/*****************************************************************************/
/* NPDS-Protect                                                              */
/* ============                                                              */
/*                                                                           */
/* Part of NPDS, http://www.npds.org                                         */
/* Adapted from NPDS by David MARTINET, http://e-concept-applications.fr     */
/* Technical support : npds-protect@e-concept-applications.fr                */
/*                     or http://www.npds.org/forum.php                      */
/*                                                                           */
/*****************************************************************************/
/*  Philippe Brunier 2001-2007                                              */ 
/*                                                                           */
/* developpeur@npds.org                                                      */
/*                                                                           */
/* NPDS-Protect est le systme de protection de NPDS, logiciel sous licence  */
/* GPL. Il permet de filtrer la plupart des attaques possibles sur des       */
/* scripts PHP. NPDS-Protect est difus sous licence GPL et licence CeCILL.  */
/*                                                                           */
/* Ce logiciel est rgi par la licence CeCILL soumise au droit franais et   */
/* respectant les principes de diffusion des logiciels libres. Vous pouvez   */
/* utiliser, modifier et/ou redistribuer ce programme sous les conditions    */
/* de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA    */
/* sur le site "http://www.cecill.info".                                     */
/*                                                                           */
/* En contrepartie de l'accessibilit au code source et des droits de copie, */
/* de modification et de redistribution accords par cette licence, il n'est */
/* offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, */
/* seule une responsabilit restreinte pse sur l'auteur du programme,  le   */
/* titulaire des droits patrimoniaux et les concdants successifs.           */
/*                                                                           */
/* A cet gard  l'attention de l'utilisateur est attire sur les risques     */
/* associs au chargement,   l'utilisation,   la modification et/ou au     */
/* dveloppement et  la reproduction du logiciel par l'utilisateur tant    */
/* donn sa spcificit de logiciel libre, qui peut le rendre complexe      */
/* manipuler et qui le rserve donc  des dveloppeurs et des professionnels */
/* avertis possdant  des  connaissances  informatiques approfondies.  Les   */
/* utilisateurs sont donc invits  charger  et  tester  l'adquation  du    */
/* logiciel  leurs besoins dans des conditions permettant d'assurer la      */
/* scurit de leurs systmes et ou de leurs donnes et, plus gnralement,  */
/*  l'utiliser et l'exploiter dans les mmes conditions de scurit.        */
/*                                                                           */
/* Le fait que vous puissiez accder  cet en-tte signifie que vous avez    */
/* pris connaissance de la licence CeCILL, et que vous en avez accept les   */
/* termes.                                                                   */
/*****************************************************************************/


if (!defined('NPDS_GRAB_GLOBALS_INCLUDED')) {
    define('NPDS_GRAB_GLOBALS_INCLUDED', 1);

    // Modify the report level off PHP
    // error_reporting(0); : // report NO ERROR
    // error_reporting(E_ERROR | E_WARNING | E_PARSE); // standard ERROR report
    error_reporting(E_ERROR | E_WARNING | E_PARSE);


    if (get_magic_quotes_runtime()==1) {set_magic_quotes_runtime(0);}
    // To prevent SQL Injection when magic_quotes GPC is off
    $magicquotesGPC=get_magic_quotes_gpc();
    function addslashes_GPC(&$arr) {
       if (is_array($arr))
          @addslashes($arr);
       else
          $arr=addslashes($arr);
    }

    // include url_protect Bad Words and create the filter function
       include ("include/url_protect.php");

    function url_protect($arr,$key) {
       global $bad_uri_content;
       reset($bad_uri_content);

       if (is_array($arr)) {
          @rawurldecode($arr);
       } else {
          $arr=rawurldecode($arr);
       }
       $RQ_tmp=strtolower($arr);
       $RQ_tmp_large=strtolower($key)."=".strtolower($arr);
       while($uri_content=each($bad_uri_content)) {
          $pos=strpos($RQ_tmp,$uri_content[1]);
          $pos_large=strpos($RQ_tmp_large,$uri_content[1]);
          if (($pos!==false) OR ($pos_large!==false)) {
             echo "<html><head><title>NPDS</title></head><body bgcolor=\"white\"><br /><p align=\"center\"><span style=\"font-size: 14px; font-family: Arial; font-weight: bold; color: red;\">";
             echo "Access Denied / Acc&egrave;s Refus&eacute;";
             echo "</span>";
             echo "<br /><br /><span style=\"font-size: 12px; font-family: Arial; font-weight: bold; color: black;\">NPDS Protect - A part of <a href=\"http://www.npds.org\" target=\"blank\">NPDS</a>";
             echo "</span></p></body></html>";
             die();
          }
       }
    }

    // Get values, slash, filter and extract
    if (!empty($_GET)) {
       if (!$magicquotesGPC)
          array_walk($_GET,'addslashes_GPC');
       reset($_GET);
       array_walk($_GET,'url_protect');
       extract($_GET, EXTR_OVERWRITE);
    } else if (!empty($HTTP_GET_VARS)) {
       if (!$magicquotesGPC)
          array_walk($HTTP_GET_VARS,'addslashes_GPC');
       reset($HTTP_GET_VARS);
       array_walk($HTTP_GET_VARS,'url_protect');
       extract($HTTP_GET_VARS, EXTR_OVERWRITE);
    }

    if (!empty($_POST)) {
       if (!$magicquotesGPC)
          array_walk($_POST,'addslashes_GPC');
       reset($_POST);
//       array_walk($_POST,'url_protect');
       extract($_POST, EXTR_OVERWRITE);
    } else if (!empty($HTTP_POST_VARS)) {
       if (!$magicquotesGPC)
          array_walk($HTTP_POST_VARS,'addslashes_GPC');
       reset($HTTP_POST_VARS);
//       array_walk($HTTP_POST_VARS,'url_protect');
       extract($HTTP_POST_VARS, EXTR_OVERWRITE);
    }

    if (!empty($_COOKIE)) {
       if (!$magicquotesGPC)
          array_walk($_COOKIE,'addslashes_GPC');
       reset($_COOKIE);
       array_walk($_COOKIE,'url_protect');
       extract($_COOKIE, EXTR_OVERWRITE);
    } else if (!empty($HTTP_COOKIE_VARS)) {
       if (!$magicquotesGPC)
          array_walk($HTTP_COOKIE_VARS,'addslashes_GPC');
       reset($HTTP_COOKIE_VARS);
       array_walk($HTTP_COOKIE_VARS,'url_protect');
       extract($HTTP_COOKIE_VARS, EXTR_OVERWRITE);
    }

    if (!empty($_SERVER)) {
       extract($_SERVER, EXTR_OVERWRITE);
    } else if (!empty($HTTP_SERVER_VARS)) {
       extract($HTTP_SERVER_VARS, EXTR_OVERWRITE);
    }

    if (!empty($_ENV)) {
       extract($_ENV, EXTR_OVERWRITE);
    } else if (!empty($HTTP_ENV_VARS)) {
       extract($HTTP_ENV_VARS, EXTR_OVERWRITE);
    }

    if (!empty($_FILES)) {
       while (list($key,$value)=each($_FILES)) {
          $$key=$value['tmp_name'];
       }
    } else if (!empty($HTTP_POST_FILES)) {
       while (list($key,$value)=each($HTTP_POST_FILES)) {
          $$key=$value['tmp_name'];
      }
    }

    unset($bad_uri_content);
}
?>
